Solution/BeerOverflow/BeerOverflow/Models/BeerViewModel.cs
using BeerOverflow.Data.Entities;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Models
{
    public class BeerViewModel
    {
        public BeerViewModel()
        {

        }
        public BeerViewModel(int id, string beerName, double abv, string description,
            string beerType, int beerTypeId, string brewery, int breweryId)
        {
            this.Id = id;
            this.BeerName = beerName;
            this.AlcByVol = abv;
            this.Description = description;
            this.BeerType = beerType;
            this.BeerTypeId = beerTypeId;
            this.Brewery = brewery;
            this.BreweryId = breweryId;
        }
        public BeerViewModel(int id, string beerName, double abv, string description, string beerType,
            int beerTypeId, string brewery, int breweryId, ICollection<Review> reviews, double avgRating, DateTime? dateUnlisted)
        {
            this.Id = id;
            this.BeerName = beerName;
            this.AlcByVol = abv;
            this.Description = description;
            this.BeerType = beerType;
            this.BeerTypeId = beerTypeId;
            this.Brewery = brewery;
            this.BreweryId = breweryId;
            this.Reviews = reviews;
            this.AvgRating = avgRating;
            this.DateUnlisted = dateUnlisted;
        }
        public BeerViewModel(int id, string beerName, double abv, string description, string beerType,
    int beerTypeId, string brewery, int breweryId, double avgRating)
        {
            this.Id = id;
            this.BeerName = beerName;
            this.AlcByVol = abv;
            this.Description = description;
            this.BeerType = beerType;
            this.BeerTypeId = beerTypeId;
            this.Brewery = brewery;
            this.BreweryId = breweryId;
            this.AvgRating = avgRating;
        }

        public BeerViewModel(int id, string beerName, double abv, string description, string beerType,
int beerTypeId, string brewery, int breweryId, DateTime? dateUnlisted, double avgRating)
        {
            this.Id = id;
            this.BeerName = beerName;
            this.AlcByVol = abv;
            this.Description = description;
            this.BeerType = beerType;
            this.BeerTypeId = beerTypeId;
            this.Brewery = brewery;
            this.BreweryId = breweryId;
            this.DateUnlisted = dateUnlisted;
            this.AvgRating = avgRating;
        }
        public int Id { get; set; }

        [Required]
        [StringLength(50)]
        [DisplayName("Beer name")]
        public string BeerName { get; set; }

        [Required]
        [DisplayName("Alcohol by volume")]
        public double? AlcByVol { get; set; }

        [Required]
        [StringLength(100)]
        [DisplayName("Beer Description")]
        public string Description { get; set; }
        //public DateTime? DateUnlisted { get; set; }


        [DisplayName("Beer Style")]
        public String BeerType { get; set; }

        [Required]
        public int BeerTypeId { get; set; }

        [DisplayName("Brewery")]
        public String Brewery { get; set; }

        [Required]
        public int BreweryId { get; set; }

        [DisplayName("Unlisted date")]
        public DateTime? DateUnlisted { get; set; }

        [DisplayName("Average rating")]
        public double AvgRating { get; set; }
        public ICollection<Review> Reviews { get; set; }

        //public SearchListEnums SearchListEnums { get; set; }
    }
}

Solution/BeerOverflow/BeerOverflow/Controllers/BeerReviewController.cs
using System;
using System.Threading.Tasks;
using BeerOverflow.Data;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Web.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace BeerOverflow.Web.Controllers
{
    public class BeerReviewController : Controller
    {
        private readonly IBeerService beerService;
        private readonly IReviewService reviewService;
        private readonly BeerOverflowContext _context;

        public BeerReviewController(BeerOverflowContext context, IBeerService beerService, IReviewService reviewService)
        {
            _context = context;
            this.beerService = beerService;
            this.reviewService = reviewService;
        }

        [HttpGet]
        //[Route("{id}")]
        public async Task<IActionResult> Edit(int id)
        {
            if (id == 0)
            {
                return NotFound();
            }
            try
            {
                var brDTO = await reviewService.GetReviewAsync(id);
                var bDTO = await beerService.GetBeerAsync(brDTO.BeerId);
                var model = new BeerReviewEditViewModel(brDTO.Id, brDTO.RMessage, brDTO.User, bDTO.Id, bDTO.BeerName, bDTO.AlcByVol, bDTO.Description,
                                bDTO.BeerType, bDTO.Brewery, bDTO.AvgRating, brDTO.ReviewedOn, brDTO.DeletedOn);

                return View(model);
            }
            catch (Exception)
            {
                return NotFound();
            }
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit([Bind("Id, RMessage, IsDeleted, BeerId")] BeerReviewEditViewModel model)
        {
            try
            {
                await this.reviewService.ModifyReviewAsync(model.Id, model.RMessage, model.IsDeleted);
                var Id = model.BeerId;
                return RedirectToAction("Details","Beers", new { Id });
            }
            catch (Exception)
            {
                return NotFound();
            }
        }

    }
}

Solution/BeerOverflow/BeerOverflow/Controllers/BeersController.cs
using System;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using BeerOverflow.Data;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Web.Models;
using BeerOverflow.Services.DTO_s;
using X.PagedList;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using BeerOverflow.Data.Entities;
using System.Collections.Generic;
using Microsoft.AspNetCore.Hosting;


namespace BeerOverflow.Web.Controllers
{

    public class BeersController : Controller
    {
        private readonly IBeerService beerService;
        private readonly IReviewService reviewService;
        private readonly BeerOverflowContext _context;
        private readonly UserManager<User> _userManager;
        private IHostingEnvironment _env;

        public BeersController(BeerOverflowContext context, IBeerService beerService, 
            IReviewService reviewService, UserManager<User> userManager, IHostingEnvironment env)
        {
            _context = context;
            this.beerService = beerService;
            this.reviewService = reviewService;
            this._userManager = userManager;
            _env = env;
        }

        // GET: Beers      
        public async Task<IActionResult> Index(string sortOrder, string currentFilter, string searchString, int? page)
        {
            ViewBag.CurrentSort = sortOrder;
            ViewBag.RatingSortParm = sortOrder == "rating" ? "rating_desc" : "rating";
            ViewBag.NameSortParm = String.IsNullOrEmpty(sortOrder) ? "name_desc" : "";
            ViewBag.AbvSortParm = sortOrder == "abv" ? "abv_desc" : "abv";
            ViewBag.BeerTypeSortParm = sortOrder == "beertype" ? "beertype_desc" : "beertype";
            ViewBag.CountrySortParm = sortOrder == "country" ? "country_desc" : "country";
            ViewBag.BrewerySortParm = sortOrder == "brewery" ? "brewery_desc" : "brewery";
        
            if (searchString != null)
            {         
                page = 1;
            }
            else
            {
                searchString = currentFilter;
            }

            ViewBag.CurrentFilter = searchString;

            var role = "otherRole";
            if (User.IsInRole("Admin"))
            {
                role = "admin";
            }

            var models = beerService.GetBeers(sortOrder, currentFilter, searchString,role)
                .Select(b => new BeerViewModel(b.Id, b.BeerName, b.AlcByVol, b.Description, 
                b.BeerType, b.BeerTypeId, b.Brewery, b.BreweryId, b.DateUnlisted, b.AvgRating));

            int pageSize = 5;
            int pageNumber = (page ?? 1);
            return View(await models.ToPagedListAsync(pageNumber, pageSize));
        }

        [HttpPost]
        public async Task<IActionResult> IndexB(string sortOrder, string currentFilter, string searchString, int? page)
        {
            ViewBag.CurrentSort = sortOrder;
            ViewBag.RatingSortParm = sortOrder == "rating" ? "rating_desc" : "rating";
            ViewBag.NameSortParm = String.IsNullOrEmpty(sortOrder) ? "name_desc" : "";
            ViewBag.AbvSortParm = sortOrder == "abv" ? "abv_desc" : "abv";
            ViewBag.BeerTypeSortParm = sortOrder == "beertype" ? "beertype_desc" : "beertype";
            ViewBag.CountrySortParm = sortOrder == "country" ? "country_desc" : "country";
            ViewBag.BrewerySortParm = sortOrder == "brewery" ? "brewery_desc" : "brewery";

            var selectedValue = Request.Form["DropDownList"].ToString();

            var getBeers = beerService.GetAllBeers();
            if (searchString != null)
            {
                if(selectedValue == "Name")
                {
                    page = 1;
                    getBeers = getBeers.Where(b => b.BeerName == searchString);         
                }
                if (selectedValue == "Brewery")
                {
                    page = 1;
                    getBeers = getBeers.Where(b => b.Brewery == searchString);
                }
                if (selectedValue == "Style")
                {
                    page = 1;
                    getBeers = getBeers.Where(b => b.BeerType == searchString);
                }
            }
            else
            {
                searchString = currentFilter;
            }

            ViewBag.CurrentFilter = searchString;

            var role = "otherRole";
            if (User.IsInRole("Admin"))
            {
                role = "admin";
            }

            var models = getBeers
             .Select(b => new BeerViewModel(b.Id, b.BeerName, b.AlcByVol, b.Description,
             b.BeerType, b.BeerTypeId, b.Brewery, b.BreweryId, b.DateUnlisted, b.AvgRating));

            int pageSize = 5;
            int pageNumber = (page ?? 1);
            return View(await models.ToPagedListAsync(pageNumber, pageSize));

        }


        // GET: Beers/Details/5
        //[Route("{id}")]
        public async Task<IActionResult> Details(int id)
        {
            if (id == 0)
            {
                return NotFound();
            }
            try
            {
                var beerDTO = await beerService.GetBeerAsync(id);
                var model = new BeerViewModel(beerDTO.Id, beerDTO.BeerName, beerDTO.AlcByVol, beerDTO.Description,
                    beerDTO.BeerType, beerDTO.BeerTypeId, beerDTO.Brewery, beerDTO.BreweryId,
                    beerDTO.Reviews, beerDTO.AvgRating,beerDTO.DateUnlisted);

                var imgPath = beerDTO.ImgPath;
                var absPath = _env.WebRootPath + imgPath;
                if (!System.IO.File.Exists(absPath))
                {
                    imgPath = @"\Images\Beer\PlaceHolder.png";
                }

                ViewBag.Imagepath = imgPath;

                return View(model);
            }
            catch (Exception)
            {
                return NotFound();
            }
        }

        // GET: Beers/Create
        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {
            ViewData["BeerTypeId"] = new SelectList(_context.BeerTypes, "Id", "Type");
            ViewData["BreweryId"] = new SelectList(_context.Breweries, "Id", "Name");
            ViewData["CountryId"] = new SelectList(_context.Countries, "Id", "Name");
            return View();
        }

        // POST: Beers/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.

        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create([Bind("BeerName,AlcByVol,Description,BeerTypeId,BreweryId")] BeerViewModel model)
        {
            if (ModelState.IsValid)
            {
                var beerDto = new BeerDTO(model.BeerName, model.BeerTypeId, model.BreweryId, (double)model.AlcByVol, model.Description);
                var beer = beerService.CreateBeer(beerDto);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            ViewData["BeerTypeId"] = new SelectList(_context.BeerTypes, "Id", "Type");
            ViewData["BreweryId"] = new SelectList(_context.Breweries, "Id", "Name");
            ViewData["CountryId"] = new SelectList(_context.Countries, "Id", "Name");

            return View(model);
        }

        // GET: Beers/Edit/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var beer = await _context.Beers.FindAsync(id);
            if (beer == null)
            {
                return NotFound();
            }
            ViewData["BeerTypeId"] = new SelectList(_context.BeerTypes, "Id", "Type");
            ViewData["BreweryId"] = new SelectList(_context.Breweries, "Id", "Name");
            ViewData["CountryId"] = new SelectList(_context.Countries, "Id", "Name");
            return View(beer);
        }

        // POST: Beers/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("Id,BeerName,AlcByVol,Description,DateUnlisted,CountryId,BeerTypeId,BreweryId")] BeerViewModel model)
        {
            if (id != model.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    //TODO is it possible to be model
                    var beerName = model.BeerName;
                    var alkByVol = model.AlcByVol;
                    var descr = model.Description;
                    var beerTypeId = model.BeerTypeId;
                    var breweryId = model.BreweryId;
                    beerService.UpdateBeer(id, beerName, alkByVol, descr, beerTypeId, breweryId);
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!BeerExists(model.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            ViewData["BeerTypeId"] = new SelectList(_context.BeerTypes, "Id", "Type");
            ViewData["BreweryId"] = new SelectList(_context.Breweries, "Id", "Name");
            ViewData["CountryId"] = new SelectList(_context.Countries, "Id", "Name");

Solution/BeerOverflow/BeerOverflow/Views/Beers/AddReview.cshtml
@model BeerOverflow.Web.Models.BeerReviewViewModel

@{
    ViewData["Title"] = "AddReview";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<link href="//maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
<script src="//maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>

<head>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <style>
        .fa-star {
            color: gainsboro
        }

        .checked {
            color: orange;
        }
    </style>
</head>

<h1>Review beer</h1>

<div>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.BeerName)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.BeerName)

        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.AlcByVol)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.AlcByVol)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Description)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Description)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.BeerType)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.BeerType)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Brewery)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Brewery)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.AvgRating)
        </dt>
        <dd class="col-sm-10">
            @if (Model.AvgRating == 0)
            {
            <p class="text-secondary">Not rated</p>
            }
            else
            {
                @for (int i = 0; i < (int)@Model.AvgRating; i++)
                {
                    <span class="fa fa-star checked"></span>
                }
                @for (int i = (int)@Model.AvgRating; i < 5; i++)
                {
                    <span class="fa fa-star"></span>
                }
            }
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Index">Back to List</a>
</div>

<div class="row">
    <div class="col-md-4">
        <form asp-action="AddReview">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="RMessage" class="control-label"></label>
                <textarea asp-for="RMessage" class="form-control" ></textarea>
                <span asp-validation-for="RMessage" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Rating" class="control-label"></label>
                <select asp-for="Rating" class="form-control" asp-items="@new SelectList(new List<int>() { 1, 2, 3, 4, 5 });">@*</select>*@
                <option value=""> Select Rating </option></select>
                <span asp-validation-for="Rating" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Add Review" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

@if(ViewBag.Message != null)
{
    <script type="text/javascript">
        window.onload = function () {
            alert("@ViewBag.Message");

        };
    </script>
}


























@*<form id="formCompose" action="@Url.Action("MyAction", "MyController")" method="post" onsubmit="return VerifyRating()">
        <div class="modal" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Review beer</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <textarea class="form-control" rows="6" cols="50" name="beerReview" id="beerIdReview"></textarea>
                        <div onmouseout="CRateSelected()">
                            <span id="span1" onmouseout="CRateOut(1)" onmouseover="CRateOver(1)" onclick="CRateClick(1)" class="glyphicon glyphicon-star-empty"></span>
                            <span id="span2" onmouseout="CRateOut(2)" onmouseover="CRateOver(2)" onclick="CRateClick(2)" class="glyphicon glyphicon-star-empty"></span>
                            <span id="span3" onmouseout="CRateOut(3)" onmouseover="CRateOver(3)" onclick="CRateClick(3)" class="glyphicon glyphicon-star-empty"></span>
                            <span id="span4" onmouseout="CRateOut(4)" onmouseover="CRateOver(4)" onclick="CRateClick(4)" class="glyphicon glyphicon-star-empty"></span>
                            <span id="span5" onmouseout="CRateOut(5)" onmouseover="CRateOver(5)" onclick="CRateClick(5)" class="glyphicon glyphicon-star-empty"></span>
                        </div>
                        <div>
                            <input type="hidden" name="rating" id="lblRating" value="0" />
                        </div>

                        <div>
                            <input type="hidden" name="reviewId" id="lblRating" value="@ViewBag.Id" />
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="button" class="btn btn-primary" onclick="$('#delete-form').submit()">Save review</button>
                    </div>
                </div>
            </div>
        </div>
    </form>*@

Solution/BeerOverflow/BeerOverflow/Views/Beers/Create.cshtml
@model BeerOverflow.Web.Models.BeerViewModel

@{
    ViewData["Title"] = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Create</h1>

<h4>Beer</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="BeerName" class="control-label"></label>
                <input asp-for="BeerName" class="form-control" />
                <span asp-validation-for="BeerName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="AlcByVol" class="control-label"></label>
                <input asp-for="AlcByVol" class="form-control" />
                <span asp-validation-for="AlcByVol" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="BeerType" class="control-label"></label>
                <select asp-for="BeerTypeId" class="form-control" asp-items="ViewBag.BeerTypeId" ><option value=""> Select Style </option></select>
                <span asp-validation-for="BeerTypeId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Brewery" class="control-label"></label>
                <select asp-for="BreweryId" class="form-control" asp-items="ViewBag.BreweryId"><option value=""> Select Brewery </option></select>
                <span asp-validation-for="BreweryId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

Solution/BeerOverflow/BeerOverflow/Views/Beers/Details.cshtml
@model BeerOverflow.Web.Models.BeerViewModel;

@{
    ViewData["Title"] = "Details";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<link href="//maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
<script src="//maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
<head>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <style>
        .fa-star {
            color: gainsboro
        }

        .checked {
            color: orange;
        }
    </style>
</head>
<h1>Details</h1>

<div>
    <h4>Beer</h4>
    <hr />
    <div class="row">
        <dl class="col-sm-8">
            <div class="row">
                <dt class="col-sm-4">
                    @Html.DisplayNameFor(model => model.BeerName)
                </dt>
                <dd class="col-sm-8">
                    @Html.DisplayFor(model => model.BeerName)
                </dd>
            </div>
            <div class="row">
                <dt class="col-sm-4">
                    @Html.DisplayNameFor(model => model.AlcByVol)
                </dt>
                <dd class="col-sm-8">
                    @Html.DisplayFor(model => model.AlcByVol)
                </dd>
            </div>
            <div class="row">
                <dt class="col-sm-4">
                    @Html.DisplayNameFor(model => model.Description)
                </dt>
                <dd class="col-sm-8">
                    @Html.DisplayFor(model => model.Description)
                </dd>
            </div>
            <div class="row">
                <dt class="col-sm-4">
                    @Html.DisplayNameFor(model => model.BeerType)
                </dt>
                <dd class="col-sm-8">
                    @Html.DisplayFor(model => model.BeerType)
                </dd>
            </div>
            <div class="row">
                <dt class="col-sm-4">
                    @Html.DisplayNameFor(model => model.Brewery)
                </dt>
                <dd class="col-sm-8">
                    @Html.DisplayFor(model => model.Brewery)
                </dd>
            </div>
            <div class="row">
                <dt class="col-sm-4">
                    @Html.DisplayNameFor(model => model.AvgRating)
                </dt>
                <dd class="col-sm-8">
                    @if (Model.AvgRating == 0)
                    {
                        <text>Not rated yet</text>
                    }
                    else
                    {
                        @for (int i = 0; i < (int)@Model.AvgRating; i++)
                        {
                            <span class="fa fa-star checked"></span>
                        }
                        @for (int i = (int)@Model.AvgRating; i < 5; i++)
                        {
                            <span class="fa fa-star"></span>
                        }
                    }
                </dd>
            </div>
            <div class="row">
                @if (User.IsInRole("Admin"))
                {
                    <dt class="col-sm-4">
                        @Html.DisplayNameFor(model => model.DateUnlisted)
                    </dt>
                    <dd class="col-sm-8">
                        @if (Model.DateUnlisted == null)
                        {
                            <p class="text-secondary">Not unlisted</p>
                        }
                        else
                        {
                            @Html.DisplayFor(model => model.DateUnlisted)
                        }
                    </dd>
                }
            </div>
        </dl>
        <div class="col-sm-4">
            <img src=@ViewBag.Imagepath alt="There's no beer" class="rounded float-right rounded" />
        </div>
    </div>
</div>
<div>
    @if (User.IsInRole("Admin"))
    {
        <a asp-action="Edit" asp-route-id="@Model.Id">Edit</a>
        <a asp-action="Index">Back to List</a>
    }
    else
    {
        <a asp-action="Index">Back to List</a>
    }
</div>

<h2> Reviews </h2>
@if (Model.Reviews.Count == 0)
{
    <p>There's no reviews for this beer</p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>
                    Rating
                </th>
                <th>
                    Review Message
                </th>
                <th>
                    Username
                </th>
                <th>
                    Reviewed On
                </th>
            </tr>
        </thead>
        <tbody>
            @if (User.IsInRole("Admin"))
            {
                @foreach (var review in Model.Reviews)
                {
                    <tr>
                        <td>
                            @for (int i = 0; i < @review.Rating; i++)
                            {
                                <span class="fa fa-star checked"></span>
                            }
                            @for (int i = @review.Rating; i < 5; i++)
                            {
                                <span class="fa fa-star"></span>
                            }
                        </td>
                        <td>
                            @Html.DisplayFor(model => review.RMessage)
                        </td>
                        <td>
                            @Html.DisplayFor(model => review.User.UserName)
                        </td>
                        <td>
                            @Html.DisplayFor(model => review.ReviewedOn)
                        </td>
                        <td>
                            <a class="btn btn-primary" asp-controller="BeerReview" asp-action="Edit" asp-route-id="@review.Id">
                                Modify review
                            </a>
                        </td>
                    </tr>
                }
            }
            else
            {
                @foreach (var review in Model.Reviews.Where(r => r.DeletedOn == null))
                {
                    <tr>
                        <td>
                            @for (int i = 0; i < @review.Rating; i++)
                            {
                                <span class="fa fa-star checked"></span>
                            }
                            @for (int i = @review.Rating; i < 5; i++)
                            {
                                <span class="fa fa-star"></span>
                            }
                        </td>
                        <td>
                            @Html.DisplayFor(model => review.RMessage)
                        </td>
                        <td>
                            @Html.DisplayFor(model => review.User.UserName)
                        </td>
                        <td>
                            @Html.DisplayFor(model => review.ReviewedOn)
                        </td>

                    </tr>
                }
            }

        </tbody>
    </table>
}


@if ((User.IsInRole("Admin") && Model.DateUnlisted == null) || User.IsInRole("User"))
{
    <a class="btn btn-primary" asp-action="AddReview" asp-route-id="@Model.Id">
        Add review
    </a>
}